## libdispatch 5.5.3

=== src/swift/CMakeLists.txt ===

# NOTE(compnerd) Today regardless of whether or not ObjC interop is enabled,
# swift will use an autoreleased return value convention for certain CF
# functions (including some that are used/related to dispatch). This means that
# the swift compiler in callers to such functions will call the function, and
# then pass the result of the function to objc_retainAutoreleasedReturnValue. In
# a context where we have ObjC interop disabled, we do not have access to the
# objc runtime so an implementation of objc_retainAutoreleasedReturnValue is not
# available. To work around this, we provide a shim for
# objc_retainAutoreleasedReturnValue in DispatchStubs.cc that just calls retain
# on the object. Once we fix the swift compiler to switch to a different model
# for handling these arguments with objc-interop disabled these shims can be
# eliminated.
add_library(DispatchStubs STATIC
  DispatchStubs.cc)
target_include_directories(DispatchStubs PRIVATE
  ${PROJECT_SOURCE_DIR})
set_target_properties(DispatchStubs PROPERTIES
  POSITION_INDEPENDENT_CODE YES)

add_library(swiftDispatch
  Block.swift
  Data.swift
  Dispatch.swift
  IO.swift
  Private.swift
  Queue.swift
  Source.swift
  Time.swift
  Wrapper.swift)
target_compile_options(swiftDispatch PRIVATE
  "SHELL:-Xcc -fblocks"
  "SHELL:-Xcc -fmodule-map-file=${PROJECT_SOURCE_DIR}/dispatch/module.modulemap"
  "SHELL:-Xcc -I${PROJECT_SOURCE_DIR}")
set_target_properties(swiftDispatch PROPERTIES
  Swift_MODULE_NAME Dispatch
  Swift_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/swift
  INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_BINARY_DIR}/swift)
target_link_libraries(swiftDispatch PRIVATE
  DispatchStubs
  BlocksRuntime::BlocksRuntime)
target_link_libraries(swiftDispatch PUBLIC
  dispatch)
add_dependencies(swiftDispatch module-maps)

get_swift_host_arch(swift_arch)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/swift/Dispatch.swiftmodule
  ${CMAKE_CURRENT_BINARY_DIR}/swift/Dispatch.swiftdoc
  DESTINATION ${INSTALL_TARGET_DIR}/${swift_arch})
set_property(GLOBAL APPEND PROPERTY DISPATCH_EXPORTS swiftDispatch)
install(TARGETS swiftDispatch
  EXPORT dispatchExports
  ARCHIVE DESTINATION ${INSTALL_TARGET_DIR}
  LIBRARY DESTINATION ${INSTALL_TARGET_DIR}
  RUNTIME DESTINATION bin)
if(NOT BUILD_SHARED_LIBS)
  set_property(GLOBAL APPEND PROPERTY DISPATCH_EXPORTS DispatchStubs)
  install(TARGETS DispatchStubs
    EXPORT dispatchExports
    DESTINATION ${INSTALL_TARGET_DIR})
elseif(NOT CMAKE_SYSTEM_NAME MATCHES "Darwin|Windows")
  target_link_options(swiftDispatch PRIVATE "SHELL:-no-toolchain-stdlib-rpath")
  set_target_properties(swiftDispatch PROPERTIES INSTALL_RPATH "$ORIGIN")
endif()

## libdispatch 0~svn188

=== debian/changelog ===
libdispatch (0~svn188-2) unstable; urgency=low

  * Add pkg-config as a dependency (fixes FTBFS)

 -- Mark Heily <mark@heily.com>  Tue, 13 Jul 2010 22:45:01 -0400

libdispatch (0~svn188-1) unstable; urgency=low

  * Initial upload (Closes: #576638)

 -- Mark Heily <mark@heily.com>  Mon, 05 Apr 2010 23:00:34 -0400

=== debian/control ===
Source: libdispatch
Priority: extra
Maintainer: Mark Heily <mark@heily.com>
Build-Depends: debhelper (>= 7.0.50~), libblocksruntime0, libblocksruntime-dev, libkqueue0, libkqueue-dev, libbsd0, libbsd-dev, autotools-dev, pkg-config, libtool, clang
Standards-Version: 3.8.4
Section: libs
Homepage: http://libdispatch.macosforge.org/

Package: libdispatch-dev
Section: libdevel
Architecture: any
Depends: libdispatch0 (= ${binary:Version}), ${misc:Depends}, libkqueue-dev, libblocksruntime-dev
Recommends: clang
Description: development files for the Grand Central Dispatch API
 The libdispatch project consists of the user space implementation of 
 the Grand Central Dispatch API as seen in Mac OS X version 10.6 
 (Snow Leopard).
 .
 This package contains the headers, manpages, and other files needed
 to build programs that use libdispatch.

Package: libdispatch0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: user space implementation of the Grand Central Dispatch API
 The libdispatch project consists of the user space implementation of 
 the Grand Central Dispatch API as seen in Mac OS X version 10.6 
 (Snow Leopard).

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	CC=clang ./configure --prefix=/usr

%:
	dh $@

## libdispatch 0~svn197

=== debian/changelog ===
libdispatch (0~svn197-3.3ubuntu2) vivid; urgency=medium

  * Strip -fstack-protector-strong from CFLAGS too.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Nov 2014 17:10:34 +0000

libdispatch (0~svn197-3.3ubuntu1) vivid; urgency=medium

  * Resynchronise with Debian.  Remaining changes:
    - Strip --param=ssp-buffer-size=4 from CFLAGS; clang doesn't support it
      and so we end up omitting Blocks support.
    - Strip -fstack-protector from CFLAGS; this causes a link failure with
      clang on at least some architectures.
    - Fix build with 'ld --no-add-needed'.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Nov 2014 16:54:38 +0000

libdispatch (0~svn197-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Build successfully on mips/mipesl
    Add -fPIC flag for mips/mipsel
    Patch by Dejan Latinovic
    Closes: #741943

 -- Anibal Monsalve Salazar <anibal@debian.org>  Mon, 17 Mar 2014 15:36:52 +0000

libdispatch (0~svn197-3.2) unstable; urgency=low

  * Non-maintainer upload.
  * Detect GNU linker on host_os-es other than linux-gnu (Closes: #660671)

 -- Balint Reczey <balint@balintreczey.hu>  Tue, 12 Nov 2013 17:47:45 +0100

libdispatch (0~svn197-3.1ubuntu1) quantal; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Strip --param=ssp-buffer-size=4 from CFLAGS; clang doesn't support it
      and so we end up omitting Blocks support.
    - Strip -fstack-protector from CFLAGS; this causes a link failure with
      clang on at least some architectures.
    - Fix build with 'ld --no-add-needed'.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 10 Aug 2012 15:08:39 +0100

libdispatch (0~svn197-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix use SSE2 instructions in i386. (Closes: #660806)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 10 Jul 2012 02:05:06 +0900

libdispatch (0~svn197-3ubuntu1) precise; urgency=low

  * Strip --param=ssp-buffer-size=4 from CFLAGS; clang doesn't support it
    and so we end up omitting Blocks support (LP: #935090).
  * Strip -fstack-protector from CFLAGS; this causes a link failure with
    clang on at least some architectures.
  * Fix build with 'ld --no-add-needed'.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 23 Apr 2012 13:43:20 +0100

libdispatch (0~svn197-3) unstable; urgency=low

  * Replace individual patches with a combined libdispatch-r197_v2 patch.
  * Add workaround for eglibc bug #631888.
  * The configure script now defaults to Clang if it is available.

 -- Mark Heily <mark@heily.com>  Tue, 28 Jun 2011 22:20:40 -0400

libdispatch (0~svn197-2) unstable; urgency=low

  * Require clang >= 2.8
  * patches/dispatch_main: prevent the process from becoming a zombie.
  * patches/__builtin_expect: removed due to use of >= 2.8
  * patches/use_libm: removed due to use of clang >= 2.8
  * Add a Build-Depends on dh-autoreconf, and enable this in debian/rules

 -- Mark Heily <mark@heily.com>  Wed, 18 May 2011 22:28:58 -0400

libdispatch (0~svn197-1) unstable; urgency=low

  * Upgrade to r197 from the upstream source repository.
  * Remove all Debian-specific patches.
  * Remove libbsd as a dependency.
  * Add a dependency on libpthread-workqueue.

 -- Mark Heily <mark@heily.com>  Sun, 6 Mar 2011 15:31:39 -0400

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: libdispatch
 Priority: extra
-Maintainer: Mark Heily <mark@heily.com>
-Build-Depends: debhelper (>= 7.0.50~), libblocksruntime0, libblocksruntime-dev, libkqueue0, libkqueue-dev, libbsd0, libbsd-dev, autotools-dev, pkg-config, libtool, clang
-Standards-Version: 3.8.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mark Heily <mark@heily.com>
+Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 7.0.50~), dh-autoreconf, libblocksruntime0, libblocksruntime-dev, libkqueue0, libkqueue-dev, libpthread-workqueue-dev, autotools-dev, pkg-config, libtool, clang (>= 2.8) 
+Standards-Version: 3.9.2
 Section: libs
 Homepage: http://libdispatch.macosforge.org/
 
 Package: libdispatch-dev
 Section: libdevel
 Architecture: any
-Depends: libdispatch0 (= ${binary:Version}), ${misc:Depends}, libkqueue-dev, libblocksruntime-dev
+Depends: libdispatch0 (= ${binary:Version}), ${misc:Depends}, libkqueue-dev, libblocksruntime-dev, libpthread-workqueue-dev
 Recommends: clang
 Description: development files for the Grand Central Dispatch API
  The libdispatch project consists of the user space implementation of

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS := $(shell DEB_CFLAGS_MAINT_STRIP='-fstack-protector --param=ssp-buffer-size=4 -fstack-protector-strong' dpkg-buildflags --get CFLAGS)

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
	CFLAGS+=-fPIC
	export CFLAGS
endif

#override_dh_auto_configure:
#	CC=clang ./configure --prefix=/usr

%:
	dh $@ --with autoreconf

## libdispatch 5.5.3

=== debian/changelog ===
libdispatch (5.5.3-0.0~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Remove dmo branding.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 01 Jul 2022 10:47:06 -0700

libdispatch-dmo (5.5.3-0.0) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 07 Mar 2022 23:41:50 +0100

libdispatch-dmo (5.4.2-0.0) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 08 Sep 2021 09:32:46 +0200

=== debian/control ===
Source: libdispatch
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Homepage: http://libdispatch.macosforge.org/
Standards-Version: 4.6.0
Build-Depends: clang,
               cmake,
               debhelper-compat (= 13),
               libkqueue-dev (>= 2.5.1~),
               libpthread-workqueue-dev,
               libtool,
               ninja-build,
               pkg-config,
               quilt

Package: libdispatch1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: user space implementation of the Grand Central Dispatch API
 The libdispatch project consists of the user space implementation of the
 Grand Central Dispatch API as seen in Mac OS X version 10.6 (Snow Leopard).

Package: libdispatch-dev
Section: libdevel
Architecture: any
Depends: libblocksruntime-dev,
         libdispatch1 (= ${binary:Version}),
         libkqueue-dev,
         libpthread-workqueue-dev,
         ${misc:Depends}
Recommends: clang
Description: development files for the Grand Central Dispatch API
 The libdispatch project consists of the user space implementation of the
 Grand Central Dispatch API as seen in Mac OS X version 10.6 (Snow Leopard).
 .
 This package contains the headers, manpages, and other files needed to
 build programs that use libdispatch.

Package: libblocksruntime1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Blocks Runtime library
 Blocks are a proposed extension to the C, Objective C, and C++ languages
 developed by Apple to support the Grand Central Dispatch concurrency engine.
 Blocks are anonymous inline functions that automatically capture a read-only
 copy of local variables, and have read-write access to local variables that
 are declared with the "__block" storage class.
 .
 This package contains a library that is needed by programs that use Blocks.

Package: libblocksruntime-dev
Section: libdevel
Architecture: any
Depends: libblocksruntime1 (= ${binary:Version}), ${misc:Depends}
Description: Blocks Runtime (development files)
 This package contains development headers for building software that
 uses blocks.
 .
 Blocks are a proposed extension to the C, Objective C, and C++ languages
 developed by Apple to support the Grand Central Dispatch concurrency engine.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter-out armel powerpc,$(DEB_BUILD_ARCH)))
        export DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

export CC = clang
export CXX = clang++

# Source
# https://github.com/apple/swift-corelibs-libdispatch/releases/tag/swift-5.4.2-RELEASE

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DBUILD_SHARED_LIBS=ON

#	exit 1

override_dh_clean:
	dh_clean dispatch/module.modulemap private/module.modulemap

# MX don't need no stinkin' dbgsyms
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## libdispatch 5.7.3

=== debian/changelog ===
libdispatch (5.7.3-0.1~mx23+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 09 Mar 2023 14:06:37 -0800

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,6 @@
                libtool,
                ninja-build,
                pkg-config,
-               quilt
 
 Package: libdispatch1
 Architecture: any

## libdispatch 5.10.1

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15.1)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# NOTE(compnerd) enable CMP0091 - select MSVC runtime based on
# CMAKE_MSVC_RUNTIME_LIBRARY.  Requires CMake 3.15 or newer.
if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()

project(dispatch
  VERSION 1.3
  LANGUAGES C CXX)

if("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC")
  include(ClangClCompileRules)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  include(DispatchWindowsSupport)
  dispatch_windows_arch_spelling(${CMAKE_SYSTEM_PROCESSOR} DISPATCH_MSVC_ARCH)
  dispatch_windows_include_for_arch(${DISPATCH_MSVC_ARCH} DISPATCH_INCLUDES)
  include_directories(BEFORE SYSTEM ${DISPATCH_INCLUDES})
  dispatch_windows_lib_for_arch(${CMAKE_SYSTEM_PROCESSOR} DISPATCH_LIBDIR)
  link_directories(${DISPATCH_LIBDIR})

  include(CheckCSourceCompiles)
  check_c_source_compiles([=[
#include <Windows.h>
int main(int argc, char *argv[]) {
  switch ((LOGICAL_PROCESSOR_RELATIONSHIP)0) {
  case RelationProcessorDie:
  case RelationNumaNodeEx:
    return 0;
  }
  return 0;
}
]=] DISPATCH_HAVE_EXTENDED_SLPI_20348)
  if(DISPATCH_HAVE_EXTENDED_SLPI_20348)
    add_compile_definitions(DISPATCH_HAVE_EXTENDED_SLPI_20348)
  endif()

  check_c_source_compiles([=[
#include <Windows.h>
int main(int argc, char *argv[]) {
  switch ((LOGICAL_PROCESSOR_RELATIONSHIP)0) {
  case RelationProcessorModule:
    return 0;
  }
  return 0;
}
]=] DISPATCH_HAVE_EXTENDED_SLPI_22000)
  if(DISPATCH_HAVE_EXTENDED_SLPI_22000)
    add_compile_definitions(DISPATCH_HAVE_EXTENDED_SLPI_22000)
  endif()
endif()

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED YES)

set(CMAKE_CXX_STANDARD 11)

set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_C_VISIBILITY_INLINES_HIDDEN YES)

# NOTE(compnerd) this is a horrible workaround for Windows to ensure that the
# tests can run as there is no rpath equivalent and `PATH` is used to lookup the
# libraries.
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(GNUInstallDirs)
include(CTest)

include(DispatchAppleOptions)
include(DispatchSanitization)
include(DispatchCompilerWarnings)
include(DTrace)
include(SwiftSupport)

# NOTE(abdulras) this is the CMake supported way to control whether we generate
# shared or static libraries.  This impacts the behaviour of `add_library` in
# what type of library it generates.
option(BUILD_SHARED_LIBS "build shared libraries" ON)

option(DISPATCH_ENABLE_ASSERTS "enable debug assertions" FALSE)

option(ENABLE_DISPATCH_INIT_CONSTRUCTOR "enable libdispatch_init as a constructor" ON)
set(USE_LIBDISPATCH_INIT_CONSTRUCTOR ${ENABLE_DISPATCH_INIT_CONSTRUCTOR})

option(ENABLE_DTRACE "enable dtrace support" "")

if(CMAKE_SYSTEM_NAME STREQUAL Darwin OR CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
  set(ENABLE_INTERNAL_PTHREAD_WORKQUEUES_DEFAULT OFF)
else()
  set(ENABLE_INTERNAL_PTHREAD_WORKQUEUES_DEFAULT ON)
endif()
option(ENABLE_INTERNAL_PTHREAD_WORKQUEUES "use libdispatch's own implementation of pthread workqueues" ${ENABLE_INTERNAL_PTHREAD_WORKQUEUES_DEFAULT})
if(ENABLE_INTERNAL_PTHREAD_WORKQUEUES)
  set(DISPATCH_USE_INTERNAL_WORKQUEUE 1)
  set(HAVE_PTHREAD_WORKQUEUES 0)
else()
  check_include_files(pthread/workqueue_private.h HAVE_PTHREAD_WORKQUEUE_PRIVATE_H)
  if(HAVE_PTHREAD_WORKQUEUE_PRIVATE_H)
    set(HAVE_PTHREAD_WORKQUEUES 1)
    set(DISPATCH_USE_INTERNAL_WORKQUEUE 0)
  else()
    set(HAVE_PTHREAD_WORKQUEUES 0)
    set(DISPATCH_USE_INTERNAL_WORKQUEUE 1)
  endif()
endif()

option(INSTALL_PRIVATE_HEADERS "installs private headers in the same location as the public ones" OFF)

option(ENABLE_SWIFT "enable libdispatch swift overlay" OFF)
if(ENABLE_SWIFT)
  enable_language(Swift)
endif()

option(ENABLE_THREAD_LOCAL_STORAGE "enable usage of thread local storage via _Thread_local" ON)
set(DISPATCH_USE_THREAD_LOCAL_STORAGE ${ENABLE_THREAD_LOCAL_STORAGE})


check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)
if(_GNU_SOURCE)
  set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} -D_GNU_SOURCE)
endif()

check_c_source_compiles("void __attribute__((__noreturn__)) main() { __builtin_trap(); }"
                        __BUILTIN_TRAP)
if(__BUILTIN_TRAP)
  set(HAVE_NORETURN_BUILTIN_TRAP 1)
endif()

if(NOT CMAKE_SYSTEM_NAME STREQUAL Android)
  find_package(LibRT)
endif()

check_function_exists(_pthread_workqueue_init HAVE__PTHREAD_WORKQUEUE_INIT)
check_function_exists(getprogname HAVE_GETPROGNAME)
check_function_exists(mach_absolute_time HAVE_MACH_ABSOLUTE_TIME)
check_function_exists(mach_approximate_time HAVE_MACH_APPROXIMATE_TIME)
check_function_exists(mach_port_construct HAVE_MACH_PORT_CONSTRUCT)
check_function_exists(malloc_create_zone HAVE_MALLOC_CREATE_ZONE)
check_function_exists(posix_fadvise HAVE_POSIX_FADVISE)
check_function_exists(posix_spawnp HAVE_POSIX_SPAWNP)
check_function_exists(pthread_key_init_np HAVE_PTHREAD_KEY_INIT_NP)
check_function_exists(pthread_attr_setcpupercent_np HAVE_PTHREAD_ATTR_SETCPUPERCENT_NP)
check_function_exists(pthread_yield_np HAVE_PTHREAD_YIELD_NP)
check_function_exists(pthread_main_np HAVE_PTHREAD_MAIN_NP)
check_function_exists(pthread_workqueue_setdispatch_np HAVE_PTHREAD_WORKQUEUE_SETDISPATCH_NP)
check_function_exists(strlcpy HAVE_STRLCPY)
check_function_exists(sysconf HAVE_SYSCONF)
check_function_exists(arc4random HAVE_ARC4RANDOM)

check_include_files("TargetConditionals.h" HAVE_TARGETCONDITIONALS_H)
check_include_files("dlfcn.h" HAVE_DLFCN_H)
check_include_files("fcntl.h" HAVE_FCNTL_H)
check_include_files("inttypes.h" HAVE_INTTYPES_H)
check_include_files("libkern/OSAtomic.h" HAVE_LIBKERN_OSATOMIC_H)
check_include_files("libkern/OSCrossEndian.h" HAVE_LIBKERN_OSCROSSENDIAN_H)
check_include_files("libproc_internal.h" HAVE_LIBPROC_INTERNAL_H)
check_include_files("mach/mach.h" HAVE_MACH)
if(HAVE_MACH)
  set(__DARWIN_NON_CANCELABLE 1)
else()
  set(__DARWIN_NON_CANCELABLE 0)
endif()
check_include_files("malloc/malloc.h" HAVE_MALLOC_MALLOC_H)
check_include_files("memory.h" HAVE_MEMORY_H)
check_include_files("pthread/qos.h" HAVE_PTHREAD_QOS_H)
check_include_files("pthread/workqueue_private.h" HAVE_PTHREAD_WORKQUEUE_PRIVATE_H)
check_include_files("pthread_machdep.h" HAVE_PTHREAD_MACHDEP_H)
check_include_files("pthread_np.h" HAVE_PTHREAD_NP_H)
check_include_files("pthread_workqueue.h" HAVE_PTHREAD_WORKQUEUE_H)
check_include_files("stdint.h" HAVE_STDINT_H)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("string.h" HAVE_STRING_H)
check_include_files("strings.h" HAVE_STRINGS_H)
check_include_files("sys/guarded.h" HAVE_SYS_GUARDED_H)
check_include_files("sys/stat.h" HAVE_SYS_STAT_H)
check_include_files("sys/types.h" HAVE_SYS_TYPES_H)
check_include_files("objc/objc-internal.h" HAVE_OBJC)

if(HAVE_MACH)
  set(USE_MACH_SEM 1)
else()
  set(USE_MACH_SEM 0)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  add_compile_definitions($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:USE_WIN32_SEM>)
endif()
check_library_exists(pthread sem_init "" USE_POSIX_SEM)
# NOTE: android has not always provided a libpthread, but uses the pthreads API
if(CMAKE_SYSTEM_NAME STREQUAL Android)
  set(USE_POSIX_SEM 1)
endif()

check_symbol_exists(CLOCK_UPTIME "time.h" HAVE_DECL_CLOCK_UPTIME)
check_symbol_exists(CLOCK_UPTIME_FAST "time.h" HAVE_DECL_CLOCK_UPTIME_FAST)
check_symbol_exists(CLOCK_MONOTONIC "time.h" HAVE_DECL_CLOCK_MONOTONIC)
check_symbol_exists(CLOCK_REALTIME "time.h" HAVE_DECL_CLOCK_REALTIME)
check_symbol_exists(CLOCK_MONOTONIC_COARSE "time.h" HAVE_DECL_CLOCK_MONOTONIC_COARSE)
check_symbol_exists(FD_COPY "sys/select.h" HAVE_DECL_FD_COPY)
check_symbol_exists(NOTE_LOWAT "sys/event.h" HAVE_DECL_NOTE_LOWAT)
check_symbol_exists(NOTE_NONE "sys/event.h" HAVE_DECL_NOTE_NONE)
check_symbol_exists(NOTE_REAP "sys/event.h" HAVE_DECL_NOTE_REAP)
check_symbol_exists(NOTE_REVOKE "sys/event.h" HAVE_DECL_NOTE_REVOKE)
check_symbol_exists(NOTE_SIGNAL "sys/event.h" HAVE_DECL_NOTE_SIGNAL)
check_symbol_exists(POSIX_SPAWN_START_SUSPENDED "sys/spawn.h" HAVE_DECL_POSIX_SPAWN_START_SUSPENDED)
check_symbol_exists(SIGEMT "signal.h" HAVE_DECL_SIGEMT)
check_symbol_exists(VQ_DESIRED_DISK "sys/mount.h" HAVE_DECL_VQ_DESIRED_DISK)
check_symbol_exists(VQ_NEARLOWDISK "sys/mount.h" HAVE_DECL_VQ_NEARLOWDISK)
check_symbol_exists(VQ_QUOTA "sys/mount.h" HAVE_DECL_VQ_QUOTA)
check_symbol_exists(VQ_UPDATE "sys/mount.h" HAVE_DECL_VQ_UPDATE)
check_symbol_exists(VQ_VERYLOWDISK "sys/mount.h" HAVE_DECL_VQ_VERYLOWDISK)
check_symbol_exists(VQ_FREE_SPACE_CHANGE "sys/mount.h" HAVE_DECL_VQ_FREE_SPACE_CHANGE)
check_symbol_exists(strlcpy "string.h" HAVE_STRLCPY)
check_symbol_exists(program_invocation_name "errno.h" HAVE_DECL_PROGRAM_INVOCATION_SHORT_NAME)
if (HAVE_DECL_PROGRAM_INVOCATION_SHORT_NAME)
  add_compile_definitions($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:_GNU_SOURCE=1>)
endif()
check_symbol_exists(__printflike "bsd/sys/cdefs.h" HAVE_PRINTFLIKE)

if(CMAKE_SYSTEM_NAME STREQUAL Android)
  set(ENABLE_DTRACE_DEFAULT OFF)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)
  add_compile_definitions($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:_WITH_DPRINTF>)
endif()

if(ENABLE_DTRACE)
  find_program(dtrace_EXECUTABLE dtrace)
  if(NOT dtrace_EXECUTABLE AND NOT ENABLE_DTRACE STREQUAL "")
    message(FATAL_ERROR "dtrace not found but explicitly requested")
  endif()
endif()

if(dtrace_EXECUTABLE)
  add_compile_definitions($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:DISPATCH_USE_DTRACE=1>)
else()
  add_compile_definitions($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:DISPATCH_USE_DTRACE=0>)
endif()

find_program(leaks_EXECUTABLE leaks)
if(leaks_EXECUTABLE)
  set(HAVE_LEAKS TRUE)
endif()


if(CMAKE_SYSTEM_NAME STREQUAL Darwin)
  add_compile_options($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:-fmodule-map-file=${PROJECT_SOURCE_DIR}/dispatch/darwin/module.modulemap>
                      $<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:-fmodule-map-file=${PROJECT_SOURCE_DIR}/private/darwin/module.modulemap>)
else()
  add_compile_options($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:-fmodule-map-file=${PROJECT_SOURCE_DIR}/dispatch/generic/module.modulemap>
                      $<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:-fmodule-map-file=${PROJECT_SOURCE_DIR}/private/generic/module.modulemap>)
endif()

configure_file("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
               "${PROJECT_BINARY_DIR}/config/config_ac.h")
add_compile_definitions($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:HAVE_CONFIG_H>)


if(ENABLE_SWIFT)
  set(INSTALL_TARGET_DIR "${CMAKE_INSTALL_LIBDIR}/swift$<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:_static>/$<LOWER_CASE:${CMAKE_SYSTEM_NAME}>" CACHE PATH "Path where the libraries will be installed")
  set(INSTALL_DISPATCH_HEADERS_DIR "${CMAKE_INSTALL_LIBDIR}/swift$<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:_static>/dispatch" CACHE PATH "Path where the headers will be installed for libdispatch")
  set(INSTALL_BLOCK_HEADERS_DIR "${CMAKE_INSTALL_LIBDIR}/swift$<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:_static>/Block" CACHE PATH "Path where the headers will be installed for the blocks runtime")
  set(INSTALL_OS_HEADERS_DIR "${CMAKE_INSTALL_LIBDIR}/swift$<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:_static>/os" CACHE PATH "Path where the os/ headers will be installed")
else()
  set(INSTALL_TARGET_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "Path where the libraries will be installed")
  set(INSTALL_DISPATCH_HEADERS_DIR "include/dispatch" CACHE PATH "Path where the headers will be installed")
  set(INSTALL_BLOCK_HEADERS_DIR "include" CACHE PATH "Path where the headers will be installed for the blocks runtime")

=== src/BlocksRuntime/CMakeLists.txt ===

add_library(BlocksRuntime
  data.c
  runtime.c)
if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  target_sources(BlocksRuntime PRIVATE
    BlocksRuntime.def)

  if(NOT BUILD_SHARED_LIBS)
    target_compile_definitions(BlocksRuntime PRIVATE
      BlocksRuntime_STATIC)
  endif()
endif()

target_include_directories(BlocksRuntime PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR})
if(HAVE_OBJC AND CMAKE_DL_LIBS)
  target_link_libraries(BlocksRuntime PUBLIC
    ${CMAKE_DL_LIBS})
endif()

set_target_properties(BlocksRuntime PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE)

add_library(BlocksRuntime::BlocksRuntime ALIAS BlocksRuntime)

install(FILES Block.h
        DESTINATION ${INSTALL_BLOCK_HEADERS_DIR})
if(INSTALL_PRIVATE_HEADERS)
  install(FILES Block_private.h
          DESTINATION ${INSTALL_BLOCK_HEADERS_DIR})
endif()
set_property(GLOBAL APPEND PROPERTY DISPATCH_EXPORTS BlocksRuntime)
install(TARGETS BlocksRuntime
        EXPORT dispatchExports
        ARCHIVE DESTINATION ${INSTALL_TARGET_DIR}
        LIBRARY DESTINATION ${INSTALL_TARGET_DIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/swift/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,10 @@
 target_compile_options(swiftDispatch PRIVATE
   "SHELL:-Xcc -fblocks"
   "SHELL:-Xcc -fmodule-map-file=${PROJECT_SOURCE_DIR}/dispatch/module.modulemap"
-  "SHELL:-Xcc -I${PROJECT_SOURCE_DIR}")
+  "SHELL:-Xcc -I${PROJECT_SOURCE_DIR}"
+  "SHELL:-Xcc -I${PROJECT_SOURCE_DIR}/src/swift/shims")
+target_compile_options(swiftDispatch PUBLIC
+  "SHELL:-vfsoverlay ${CMAKE_BINARY_DIR}/dispatch-vfs-overlay.yaml")
 set_target_properties(swiftDispatch PROPERTIES
   Swift_MODULE_NAME Dispatch
   Swift_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/swift
@@ -41,7 +44,6 @@
   BlocksRuntime::BlocksRuntime)
 target_link_libraries(swiftDispatch PUBLIC
   dispatch)
-add_dependencies(swiftDispatch module-maps)
 
 get_swift_host_arch(swift_arch)
 install(FILES
@@ -53,7 +55,7 @@
   EXPORT dispatchExports
   ARCHIVE DESTINATION ${INSTALL_TARGET_DIR}
   LIBRARY DESTINATION ${INSTALL_TARGET_DIR}
-  RUNTIME DESTINATION bin)
+  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 if(NOT BUILD_SHARED_LIBS)
   set_property(GLOBAL APPEND PROPERTY DISPATCH_EXPORTS DispatchStubs)
   install(TARGETS DispatchStubs

=== debian/changelog ===
libdispatch (5.10.1-1~mx21+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Apr 2025 08:39:40 -0700

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                libpthread-workqueue-dev,
                libtool,
                ninja-build,
-               pkg-config,
+               pkg-config
 
 Package: libdispatch1
 Architecture: any
